diff -Nur flexi-streams-0.7.2/input.lisp flexi-streams-0.7.2.fixed/input.lisp
--- flexi-streams-0.7.2/input.lisp	2006-10-31 16:09:08.000000000 +0200
+++ flexi-streams-0.7.2.fixed/input.lisp	2006-11-14 20:22:18.769336000 +0200
@@ -217,6 +217,9 @@
     (setf (flexi-stream-octet-stack flexi-input-stream)
           (append octets-read
                   (flexi-stream-octet-stack flexi-input-stream)))))
+(defun read-char-interactive()
+  (format *query-io* "Type a character: ")
+  (list (elt (read-line *query-io*) 0)))
 
 (defmethod stream-read-char ((stream flexi-input-stream))
   "Reads enough octets from the underlying stream to return one
@@ -233,22 +236,27 @@
              "This internal function does all the work of reading
 from the stream and converting to character codes but it doesn't
 handle line endings."
-             (cond ((ascii-name-p external-format-name)
-                    (read-char-8-bit stream +ascii-table+))
-		   ((koi8-r-name-p external-format-name)
-                    (read-char-8-bit stream +koi8-r-table+))
-                   ((iso-8859-name-p external-format-name)
-                    (read-char-8-bit stream
-                                     (cdr (assoc external-format-name +iso-8859-tables+
-                                                 :test #'eq))))
-                   ((code-page-name-p external-format-name)
-                    (read-char-8-bit stream
-                                     (cdr (assoc (external-format-id external-format)
-                                                 +code-page-tables+))))
-                   (t (case external-format-name
-                        (:utf-8 (read-char-utf-8 stream))
-                        (:utf-16 (read-char-utf-16 stream))
-                        (:utf-32 (read-char-utf-32 stream)))))))
+	     (restart-case
+		 (cond ((ascii-name-p external-format-name)
+			(read-char-8-bit stream +ascii-table+))
+		       ((koi8-r-name-p external-format-name)
+			(read-char-8-bit stream +koi8-r-table+))
+		       ((iso-8859-name-p external-format-name)
+			(read-char-8-bit stream
+					 (cdr (assoc external-format-name +iso-8859-tables+
+						     :test #'eq))))
+		       ((code-page-name-p external-format-name)
+			(read-char-8-bit stream
+					 (cdr (assoc (external-format-id external-format)
+						     +code-page-tables+))))
+		       (t (case external-format-name
+			    (:utf-8 (read-char-utf-8 stream))
+			    (:utf-16 (read-char-utf-16 stream))
+			    (:utf-32 (read-char-utf-32 stream)))))
+	       (use-value (char)
+		 :report "Specify a character to be used instead of unsuccessfully read one."
+		 :interactive read-char-interactive
+		 (char-code char)))))
       (let ((char-code (get-char-code)))
         (when (eq char-code :eof)
           (return-from stream-read-char :eof))
